package ru.landgrafhomyak.db.sql_skeleton_0.api.module

import kotlin.jvm.JvmName
import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.Table
import ru.landgrafhomyak.db.sql_skeleton_0.api.queries._Statement
import ru.landgrafhomyak.db.sql_skeleton_0.api.raw.DialectResolver
import ru.landgrafhomyak.db.sql_skeleton_0.api.runtime.InputRow
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.TableConstructor
import ru.landgrafhomyak.db.sql_skeleton_0.api.table.TableScopedObject


public interface CreateModuleScope<mUE : Any, RUNTIME_KEY : Any> {
	@Suppress("INAPPLICABLE_JVM_NAME")
	@get:JvmName("rootNs")
	public val rootNs: Namespace<mUE>

	public fun <tUE : Any> createTable(
		lifeTime: Table.LifeTime = Table.LifeTime.DATABASE_SCOPE,
		namespace: Namespace<mUE> = this.rootNs,
		name: String, initializer: TableConstructor<tUE, RUNTIME_KEY>
	): Table<tUE, mUE, RUNTIME_KEY>

	public fun moduleScopedObject(namespace: Namespace<mUE> = this.rootNs, name: String): ModuleScopedObject<mUE, RUNTIME_KEY>

	public fun <mUE : Any> substituteModule(rootNs: Namespace<mUE>, template: ModuleTemplate<mUE>): Module<mUE>

	public fun namespace(parent: Namespace<mUE>, name: String): Namespace<mUE>

	public fun addStatement(stmt: DialectResolver.Statement_Void2Void<*>)

	@LowLevelApi
	public fun <sUE : Any> addStatement(stmt: DialectResolver.Statement_Params2Void<sUE>): InputRow._Scope<sUE, Unit>
}