package ru.landgrafhomyak.db.sql_skeleton_0.api.table

import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.misc.Column
import ru.landgrafhomyak.db.sql_skeleton_0.api.raw.DialectResolver
import ru.landgrafhomyak.db.sql_skeleton_0.api.runtime.InputRow


public interface TableConstructor<tUE : Any, RUNTIME_KEY: Any> {
	public fun createTable(context: Scope<tUE, RUNTIME_KEY>): tUE

	public interface Scope<tUE : Any, RUNTIME_KEY: Any> {
		public fun <RT> column(name: String, type: DialectResolver.Type<RT>, manualCreate: Boolean = false): Column<RT, tUE, RUNTIME_KEY>
		public fun <RT, ttUE : Any> columnWithBoundType(name: String, foreign: Column<RT, ttUE, RUNTIME_KEY>): Column<RT, tUE, RUNTIME_KEY>

		public fun tableScopedObject(name: String): TableScopedObject<tUE, RUNTIME_KEY>

		public fun addAlterStatement(stmt: DialectResolver.Statement_Void2Void<*>)

		@LowLevelApi
		public fun <sUE : Any> addAlterStatement(stmt: DialectResolver.Statement_Params2Void<sUE>): InputRow._Scope<sUE, Unit>
	}
}