package ru.landgrafhomyak.db.sql_skeleton_0.api.table

import ru.landgrafhomyak.db.sql_skeleton_0.api.LowLevelApi
import ru.landgrafhomyak.db.sql_skeleton_0.api.misc.Column
import ru.landgrafhomyak.db.sql_skeleton_0.api.raw.DialectResolver
import ru.landgrafhomyak.db.sql_skeleton_0.api.runtime.InputRow


public interface TableUpgrade<tnUE : Any, toUE : Any, RUNTIME_KEY : Any> {
	public fun upgradeTable(oldTable: toUE, context: Scope<tnUE, toUE, RUNTIME_KEY>): tnUE

	public interface Scope<tnUE : Any, toUE : Any, RUNTIME_KEY : Any> : TableConstructor.Scope<tnUE, RUNTIME_KEY> {
		public fun <RT> keepColumn(c: Column<RT, toUE, RUNTIME_KEY>): Column<RT, tnUE, RUNTIME_KEY>
		public fun <RT> renameColumn(c: Column<RT, toUE, RUNTIME_KEY>, newName: String): Column<RT, tnUE, RUNTIME_KEY>
		public fun removeColumn(c: Column<*, toUE, RUNTIME_KEY>)
		public fun <RT> removeColumnAfterUpgrade(c: Column<RT, toUE, RUNTIME_KEY>): Column<RT, tnUE, RUNTIME_KEY>

		public fun <RT> keepColumnWithBoundType(c: Column<RT, toUE, RUNTIME_KEY>): Column<RT, tnUE, RUNTIME_KEY>
		public fun <RT> unbindAndKeepColumnWithBoundType(c: Column<RT, toUE, RUNTIME_KEY>): Column<RT, tnUE, RUNTIME_KEY>
		public fun <RT> renameColumnWithBoundType(c: Column<RT, toUE, RUNTIME_KEY>, newName: String): Column<RT, tnUE, RUNTIME_KEY>
		public fun <RT> unbindAndRenameColumnWithBoundType(c: Column<RT, toUE, RUNTIME_KEY>, newName: String): Column<RT, tnUE, RUNTIME_KEY>
		public fun removeColumnWithBoundType(c: Column<*, toUE, RUNTIME_KEY>)
		public fun <RT> removeColumnWithBoundTypeAfterUpgrade(c: Column<RT, toUE, RUNTIME_KEY>): Column<RT, tnUE, RUNTIME_KEY>

		public fun keepTableScopedObject(obj: TableScopedObject<toUE, RUNTIME_KEY>): TableScopedObject<tnUE, RUNTIME_KEY>
		public fun renameTableScopedObject(obj: TableScopedObject<toUE, RUNTIME_KEY>, newName: String): TableScopedObject<tnUE, RUNTIME_KEY>
		public fun removeTableScopedObject(obj: TableScopedObject<toUE, RUNTIME_KEY>): TableScopedObject<tnUE, RUNTIME_KEY>


		public fun addAlterStatementAfterUpgrade(stmt: DialectResolver.Statement_Void2Void<*>)

		@LowLevelApi
		public fun <sUE : Any> addAlterStatementAfterUpgrade(stmt: DialectResolver.Statement_Params2Void<sUE>): InputRow._Scope<sUE, Unit>
	}
}